/* A Bison parser, made by GNU Bison 2.4.266-4ff3b.  */

/* Skeleton implementation for Bison LALR(1) parsers in C++

   Copyright (C) 2002, 2003, 2004, 2005, 2006, 2007, 2008 Free Software
   Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */


/* First part of user declarations.  */
/* Line 378 of lalr1.cc  */
#line 1 "asm-parse.yy"
							// -*- C++ -*-
//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2004, 2005, 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//

//
// WARNING: Generated file, do not edit by hand!
//


#include <string>

#include "common.hh"

#include "inst/label.hh"
#include "inst/program_builder.hh"
#include "inst/exp.hh"
#include "inst/register.hh"
#include "inst/all.hh"

#include "parse/libparse.hh"

using namespace inst;

/* Line 378 of lalr1.cc  */
#line 79 "asm-parse.cc"

#include "asm-parse.hh"

/* User implementation prologue.  */
/* Line 383 of lalr1.cc  */
#line 65 "asm-parse.yy"

#include "parse/asm-scan.hh"

/* Line 383 of lalr1.cc  */
#line 90 "asm-parse.cc"

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* FIXME: INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#define YYUSE(e) ((void) (e))

/* Enable debugging if requested.  */
#if YYDEBUG

/* A pseudo ostream that takes yydebug_ into account.  */
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << std::endl;                  \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)		\
  do {					\
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);		\
  } while (false)

# define YY_STACK_PRINT()		\
  do {					\
    if (yydebug_)                       \
      yystack_print_ ();                \
  } while (false)

#else /* !YYDEBUG */

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  static_cast<void>(0)
# define YY_REDUCE_PRINT(Rule)           static_cast<void>(0)
# define YY_STACK_PRINT()                static_cast<void>(0)

#endif /* !YYDEBUG */

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyempty = true)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

/* Line 446 of lalr1.cc  */
#line 1 "[Bison:b4_percent_define_default]"

namespace yy {
/* Line 446 of lalr1.cc  */
#line 157 "asm-parse.cc"

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr = "";
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              /* Fall through.  */
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }


  /// Build a parser object.
  parser::parser (std::string &filename_yyarg, inst::ProgramBuilder &program_builder_yyarg)
    :
#if YYDEBUG
      yydebug_ (false),
      yycdebug_ (&std::cerr),
#endif
      filename (filename_yyarg),
      program_builder (program_builder_yyarg)
  {
  }

  parser::~parser ()
  {
  }


  /*---------------.
  | Symbol types.  |
  `---------------*/

  // symbol_base_type.
  template <typename Exact>
  parser::symbol_base_type<Exact>::symbol_base_type ()
    : value()
    , location()
  {
  }

  template <typename Exact>
  parser::symbol_base_type<Exact>::symbol_base_type (const location_type& l)
    : value()
    , location(l)
  {
  }

  template <typename Exact>
  parser::symbol_base_type<Exact>::symbol_base_type (const semantic_type& v, const location_type& l)
    : value(v)
    , location(l)
  {
  }

  template <typename Exact>
  const Exact&
  parser::symbol_base_type<Exact>::self () const
  {
    return static_cast<const Exact&>(*this);
  }

  template <typename Exact>
  Exact&
  parser::symbol_base_type<Exact>::self ()
  {
    return static_cast<Exact&>(*this);
  }

  template <typename Exact>
  int
  parser::symbol_base_type<Exact>::type_get () const
  {
    return self ().type_get_ ();
  }

  // symbol_type.
  parser::symbol_type::symbol_type ()
    : super_type ()
    , type ()
  {
  }

  parser::symbol_type::symbol_type (int t, const location_type& l)
    : super_type (l)
    , type (t)
  {
  }

  parser::symbol_type::symbol_type (int t, const semantic_type& v, const location_type& l)
    : super_type (v, l)
    , type (t)
  {
  }

  int
  parser::symbol_type::type_get_ () const
  {
    return type;
  }


  // stack_symbol_type.
  parser::stack_symbol_type::stack_symbol_type ()
    : super_type ()
    , state ()
  {
  }

  parser::stack_symbol_type::stack_symbol_type (state_type s, const semantic_type& v, const location_type& l)
    : super_type (v, l)
    , state (s)
  {
  }

  int
  parser::stack_symbol_type::type_get_ () const
  {
    return yystos_[state];
  }


  template <typename Exact>
  void
  parser::yy_destroy_ (const char* yymsg,
                                       symbol_base_type<Exact>& yysym) const
  {
    int yytype = yysym.type_get ();
    YYUSE (yymsg);
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);

    // User destructor.
    switch (yytype)
      {
            case 3: // "label"

/* Line 543 of lalr1.cc  */
#line 77 "asm-parse.yy"
        { delete (yysym.value.id); }
/* Line 543 of lalr1.cc  */
#line 326 "asm-parse.cc"
        break;

            case 4: // "label definition"

/* Line 543 of lalr1.cc  */
#line 78 "asm-parse.yy"
        { delete (yysym.value.id); }
/* Line 543 of lalr1.cc  */
#line 335 "asm-parse.cc"
        break;

            case 6: // "string"

/* Line 543 of lalr1.cc  */
#line 75 "asm-parse.yy"
        { delete (yysym.value.s); }
/* Line 543 of lalr1.cc  */
#line 344 "asm-parse.cc"
        break;

       default:
          break;
      }
  }

#if YYDEBUG
  template <typename Exact>
  void
  parser::yy_print_ (std::ostream& yyo,
                                     const symbol_base_type<Exact>& yysym) const
  {
    int yytype = yysym.type_get ();
    yyo << (yytype < yyntokens_ ? "token" : "nterm")
        << ' ' << yytname_[yytype] << " ("
        << yysym.location << ": ";
    switch (yytype)
      {
            case 5: // "integer"

/* Line 564 of lalr1.cc  */
#line 81 "asm-parse.yy"
        { debug_stream () << (yysym.value.i); }
/* Line 564 of lalr1.cc  */
#line 370 "asm-parse.cc"
        break;

            case 6: // "string"

/* Line 564 of lalr1.cc  */
#line 80 "asm-parse.yy"
        { debug_stream () << *(yysym.value.s); }
/* Line 564 of lalr1.cc  */
#line 379 "asm-parse.cc"
        break;

            case 7: // "register"

/* Line 564 of lalr1.cc  */
#line 80 "asm-parse.yy"
        { debug_stream () << *(yysym.value.reg); }
/* Line 564 of lalr1.cc  */
#line 388 "asm-parse.cc"
        break;

       default:
	  break;
      }
    yyo << ')';
  }
#endif

  void
  parser::yypush_ (const char* m, state_type s,
                                   symbol_type& sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (stack_symbol_type (s, sym.value, sym.location));
  }

  void
  parser::yypush_ (const char* m, stack_symbol_type& s)
  {
    if (m)
      YY_SYMBOL_PRINT (m, s);
    yystack_.push (s);
  }

  void
  parser::yypop_ (unsigned int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  parser::debug_level_type
  parser::debug_level () const
  {
    return yydebug_;
  }

  void
  parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif

  int
  parser::parse ()
  {
    /// Whether yyla contains a lookahead.
    bool yyempty = true;

    /* State.  */
    int yyn;
    int yylen = 0;
    int yystate = 0;

    /* Error handling.  */
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[2];

    /// $$ and @$.
    stack_symbol_type yylhs;

    /// The return value of parse().
    int yyresult;

    YYCDEBUG << "Starting parse" << std::endl;


    /* User initialization code.  */
    /* Line 668 of lalr1.cc  */
#line 52 "asm-parse.yy"
{
  yyla.location.begin.filename = yyla.location.end.filename = &filename;
}
/* Line 668 of lalr1.cc  */
#line 485 "asm-parse.cc"

    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_ = stack_type (0);
    yypush_ (0, 0, yyla);

    // A new state was pushed on the stack.
    // Invariant: yystate == yystack_[0].state, i.e.,
    // yystate was just pushed onto the state stack.
  yynewstate:
    YYCDEBUG << "Entering state " << yystate << std::endl;

    /* Accept?  */
    if (yystate == yyfinal_)
      goto yyacceptlab;

    goto yybackup;

    /* Backup.  */
  yybackup:

    /* Try to take a decision without lookahead.  */
    yyn = yypact_[yystate];
    if (yyn == yypact_ninf_)
      goto yydefault;

    /* Read a lookahead token.  */
    if (yyempty)
      {
        YYCDEBUG << "Reading a token: ";
        yyla.type = yytranslate_ (yylex (&yyla.value, &yyla.location));
        yyempty = false;
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.type;
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.type)
      goto yydefault;

    /* Reduce or error.  */
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
	if (yyn == 0 || yyn == yytable_ninf_)
	  goto yyerrlab;
	yyn = -yyn;
	goto yyreduce;
      }

    /* Discard the token being shifted.  */
    yyempty = true;

    /* Count tokens shifted since error; after three, turn off error
       status.  */
    if (yyerrstatus_)
      --yyerrstatus_;

    /* Shift the lookahead token.  */
    yystate = yyn;
    yypush_ ("Shifting", yystate, yyla);
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystate];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    /* If YYLEN is nonzero, implement the default value of the action:
       `$$ = $1'.  Otherwise, use the top of the stack.

       Otherwise, the following line sets YYLHS.VALUE to garbage.
       This behavior is undocumented and Bison
       users should not rely upon it.  */
    if (yylen)
      yylhs.value = yystack_[yylen - 1].value;
    else
      yylhs.value = yystack_[0].value;

    // Compute the default @$.
    {
      slice<stack_symbol_type, stack_type> slice (yystack_, yylen);
      YYLLOC_DEFAULT (yylhs.location, slice, yylen);
    }

    // Perform the reduction.
    YY_REDUCE_PRINT (yyn);
    switch (yyn)
      {
  case 7:
/* Line 787 of lalr1.cc  */
#line 204 "asm-parse.yy"
    { program_builder.define_data_label(*(yystack_[0].value.id)); }
/* Line 787 of lalr1.cc  */
#line 592 "asm-parse.cc"
    break;

  case 8:
/* Line 787 of lalr1.cc  */
#line 208 "asm-parse.yy"
    { program_builder.add_space((yystack_[0].value.i)); }
/* Line 787 of lalr1.cc  */
#line 600 "asm-parse.cc"
    break;

  case 9:
/* Line 787 of lalr1.cc  */
#line 212 "asm-parse.yy"
    { program_builder.add_byte((yystack_[0].value.i)); }
/* Line 787 of lalr1.cc  */
#line 608 "asm-parse.cc"
    break;

  case 10:
/* Line 787 of lalr1.cc  */
#line 215 "asm-parse.yy"
    { program_builder.add_half((yystack_[0].value.i)); }
/* Line 787 of lalr1.cc  */
#line 616 "asm-parse.cc"
    break;

  case 11:
/* Line 787 of lalr1.cc  */
#line 218 "asm-parse.yy"
    { program_builder.add_word((yystack_[0].value.i)); }
/* Line 787 of lalr1.cc  */
#line 624 "asm-parse.cc"
    break;

  case 12:
/* Line 787 of lalr1.cc  */
#line 220 "asm-parse.yy"
    { program_builder.add_word(new LabelExp(*(yystack_[0].value.id))); }
/* Line 787 of lalr1.cc  */
#line 632 "asm-parse.cc"
    break;

  case 13:
/* Line 787 of lalr1.cc  */
#line 223 "asm-parse.yy"
    { program_builder.add_ascii((yystack_[0].value.s)); }
/* Line 787 of lalr1.cc  */
#line 640 "asm-parse.cc"
    break;

  case 14:
/* Line 787 of lalr1.cc  */
#line 225 "asm-parse.yy"
    { program_builder.add_asciiz((yystack_[0].value.s)); }
/* Line 787 of lalr1.cc  */
#line 648 "asm-parse.cc"
    break;

  case 17:
/* Line 787 of lalr1.cc  */
#line 235 "asm-parse.yy"
    { program_builder.define_inst_label(*(yystack_[0].value.id)); }
/* Line 787 of lalr1.cc  */
#line 656 "asm-parse.cc"
    break;

  case 18:
/* Line 787 of lalr1.cc  */
#line 239 "asm-parse.yy"
    { program_builder.add_add((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 668 "asm-parse.cc"
    break;

  case 19:
/* Line 787 of lalr1.cc  */
#line 245 "asm-parse.yy"
    { program_builder.add_add((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 679 "asm-parse.cc"
    break;

  case 20:
/* Line 787 of lalr1.cc  */
#line 250 "asm-parse.yy"
    { program_builder.add_addi((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 690 "asm-parse.cc"
    break;

  case 21:
/* Line 787 of lalr1.cc  */
#line 255 "asm-parse.yy"
    { program_builder.add_addi((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 700 "asm-parse.cc"
    break;

  case 22:
/* Line 787 of lalr1.cc  */
#line 259 "asm-parse.yy"
    { program_builder.add_addu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 712 "asm-parse.cc"
    break;

  case 23:
/* Line 787 of lalr1.cc  */
#line 265 "asm-parse.yy"
    { program_builder.add_addu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 723 "asm-parse.cc"
    break;

  case 24:
/* Line 787 of lalr1.cc  */
#line 270 "asm-parse.yy"
    { program_builder.add_addiu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 734 "asm-parse.cc"
    break;

  case 25:
/* Line 787 of lalr1.cc  */
#line 275 "asm-parse.yy"
    { program_builder.add_addiu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 744 "asm-parse.cc"
    break;

  case 26:
/* Line 787 of lalr1.cc  */
#line 279 "asm-parse.yy"
    { program_builder.add_addi((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 755 "asm-parse.cc"
    break;

  case 27:
/* Line 787 of lalr1.cc  */
#line 284 "asm-parse.yy"
    { program_builder.add_addi((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 765 "asm-parse.cc"
    break;

  case 28:
/* Line 787 of lalr1.cc  */
#line 288 "asm-parse.yy"
    { program_builder.add_addiu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 776 "asm-parse.cc"
    break;

  case 29:
/* Line 787 of lalr1.cc  */
#line 293 "asm-parse.yy"
    { program_builder.add_addiu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 786 "asm-parse.cc"
    break;

  case 30:
/* Line 787 of lalr1.cc  */
#line 297 "asm-parse.yy"
    { program_builder.add_sub((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 798 "asm-parse.cc"
    break;

  case 31:
/* Line 787 of lalr1.cc  */
#line 303 "asm-parse.yy"
    { program_builder.add_sub((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 809 "asm-parse.cc"
    break;

  case 32:
/* Line 787 of lalr1.cc  */
#line 308 "asm-parse.yy"
    { program_builder.add_addi((yystack_[4].value.reg), (yystack_[2].value.reg), new OpExp(new IntExp(0), OpExp::sub, (yystack_[0].value.exp)));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 820 "asm-parse.cc"
    break;

  case 33:
/* Line 787 of lalr1.cc  */
#line 313 "asm-parse.yy"
    { program_builder.add_subu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 832 "asm-parse.cc"
    break;

  case 34:
/* Line 787 of lalr1.cc  */
#line 319 "asm-parse.yy"
    { program_builder.add_subu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 843 "asm-parse.cc"
    break;

  case 35:
/* Line 787 of lalr1.cc  */
#line 324 "asm-parse.yy"
    { program_builder.add_addiu((yystack_[4].value.reg), (yystack_[2].value.reg), new OpExp(new IntExp(0), OpExp::sub, (yystack_[0].value.exp)));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 854 "asm-parse.cc"
    break;

  case 36:
/* Line 787 of lalr1.cc  */
#line 329 "asm-parse.yy"
    { program_builder.add_sub((yystack_[2].value.reg), new Register(Register::general, Cpu::zero), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 865 "asm-parse.cc"
    break;

  case 37:
/* Line 787 of lalr1.cc  */
#line 334 "asm-parse.yy"
    { program_builder.add_sub((yystack_[0].value.reg), new Register(Register::general, Cpu::zero), (yystack_[0].value.reg));
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 875 "asm-parse.cc"
    break;

  case 38:
/* Line 787 of lalr1.cc  */
#line 338 "asm-parse.yy"
    { program_builder.add_subu((yystack_[2].value.reg), new Register(Register::general, Cpu::zero), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 886 "asm-parse.cc"
    break;

  case 39:
/* Line 787 of lalr1.cc  */
#line 343 "asm-parse.yy"
    { program_builder.add_subu((yystack_[0].value.reg), new Register(Register::general, Cpu::zero), (yystack_[0].value.reg));
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 896 "asm-parse.cc"
    break;

  case 40:
/* Line 787 of lalr1.cc  */
#line 347 "asm-parse.yy"
    { program_builder.add_abs((yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 907 "asm-parse.cc"
    break;

  case 41:
/* Line 787 of lalr1.cc  */
#line 352 "asm-parse.yy"
    { program_builder.add_abs((yystack_[0].value.reg), (yystack_[0].value.reg));
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 917 "asm-parse.cc"
    break;

  case 42:
/* Line 787 of lalr1.cc  */
#line 356 "asm-parse.yy"
    { program_builder.add_mul((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 929 "asm-parse.cc"
    break;

  case 43:
/* Line 787 of lalr1.cc  */
#line 362 "asm-parse.yy"
    { program_builder.add_mul((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 940 "asm-parse.cc"
    break;

  case 44:
/* Line 787 of lalr1.cc  */
#line 367 "asm-parse.yy"
    { program_builder.add_mul((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 951 "asm-parse.cc"
    break;

  case 45:
/* Line 787 of lalr1.cc  */
#line 372 "asm-parse.yy"
    { program_builder.add_div((yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 962 "asm-parse.cc"
    break;

  case 46:
/* Line 787 of lalr1.cc  */
#line 377 "asm-parse.yy"
    { program_builder.add_div((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 974 "asm-parse.cc"
    break;

  case 47:
/* Line 787 of lalr1.cc  */
#line 383 "asm-parse.yy"
    { program_builder.add_div((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 985 "asm-parse.cc"
    break;

  case 48:
/* Line 787 of lalr1.cc  */
#line 388 "asm-parse.yy"
    { program_builder.add_divu((yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 996 "asm-parse.cc"
    break;

  case 49:
/* Line 787 of lalr1.cc  */
#line 393 "asm-parse.yy"
    { program_builder.add_divu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1008 "asm-parse.cc"
    break;

  case 50:
/* Line 787 of lalr1.cc  */
#line 399 "asm-parse.yy"
    { program_builder.add_divu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1019 "asm-parse.cc"
    break;

  case 51:
/* Line 787 of lalr1.cc  */
#line 404 "asm-parse.yy"
    { program_builder.add_rem((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1031 "asm-parse.cc"
    break;

  case 52:
/* Line 787 of lalr1.cc  */
#line 410 "asm-parse.yy"
    { program_builder.add_rem((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1042 "asm-parse.cc"
    break;

  case 53:
/* Line 787 of lalr1.cc  */
#line 415 "asm-parse.yy"
    { program_builder.add_remu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1054 "asm-parse.cc"
    break;

  case 54:
/* Line 787 of lalr1.cc  */
#line 421 "asm-parse.yy"
    { program_builder.add_remu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1065 "asm-parse.cc"
    break;

  case 55:
/* Line 787 of lalr1.cc  */
#line 426 "asm-parse.yy"
    { program_builder.add_sll((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1076 "asm-parse.cc"
    break;

  case 56:
/* Line 787 of lalr1.cc  */
#line 431 "asm-parse.yy"
    { program_builder.add_sll((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1086 "asm-parse.cc"
    break;

  case 57:
/* Line 787 of lalr1.cc  */
#line 435 "asm-parse.yy"
    { program_builder.add_sllv((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1098 "asm-parse.cc"
    break;

  case 58:
/* Line 787 of lalr1.cc  */
#line 441 "asm-parse.yy"
    { program_builder.add_sllv((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1109 "asm-parse.cc"
    break;

  case 59:
/* Line 787 of lalr1.cc  */
#line 446 "asm-parse.yy"
    { program_builder.add_sllv((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1121 "asm-parse.cc"
    break;

  case 60:
/* Line 787 of lalr1.cc  */
#line 452 "asm-parse.yy"
    { program_builder.add_sllv((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1132 "asm-parse.cc"
    break;

  case 61:
/* Line 787 of lalr1.cc  */
#line 457 "asm-parse.yy"
    { program_builder.add_sra((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1143 "asm-parse.cc"
    break;

  case 62:
/* Line 787 of lalr1.cc  */
#line 462 "asm-parse.yy"
    { program_builder.add_sra((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1153 "asm-parse.cc"
    break;

  case 63:
/* Line 787 of lalr1.cc  */
#line 466 "asm-parse.yy"
    { program_builder.add_srav((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1165 "asm-parse.cc"
    break;

  case 64:
/* Line 787 of lalr1.cc  */
#line 472 "asm-parse.yy"
    { program_builder.add_srav((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1176 "asm-parse.cc"
    break;

  case 65:
/* Line 787 of lalr1.cc  */
#line 477 "asm-parse.yy"
    { program_builder.add_srav((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1188 "asm-parse.cc"
    break;

  case 66:
/* Line 787 of lalr1.cc  */
#line 483 "asm-parse.yy"
    { program_builder.add_srav((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1199 "asm-parse.cc"
    break;

  case 67:
/* Line 787 of lalr1.cc  */
#line 488 "asm-parse.yy"
    { program_builder.add_srl((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1210 "asm-parse.cc"
    break;

  case 68:
/* Line 787 of lalr1.cc  */
#line 493 "asm-parse.yy"
    { program_builder.add_srl((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1220 "asm-parse.cc"
    break;

  case 69:
/* Line 787 of lalr1.cc  */
#line 497 "asm-parse.yy"
    { program_builder.add_srlv((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1232 "asm-parse.cc"
    break;

  case 70:
/* Line 787 of lalr1.cc  */
#line 503 "asm-parse.yy"
    { program_builder.add_srlv((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1243 "asm-parse.cc"
    break;

  case 71:
/* Line 787 of lalr1.cc  */
#line 508 "asm-parse.yy"
    { program_builder.add_srlv((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1255 "asm-parse.cc"
    break;

  case 72:
/* Line 787 of lalr1.cc  */
#line 514 "asm-parse.yy"
    { program_builder.add_srlv((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1266 "asm-parse.cc"
    break;

  case 73:
/* Line 787 of lalr1.cc  */
#line 519 "asm-parse.yy"
    { program_builder.add_rol((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1278 "asm-parse.cc"
    break;

  case 74:
/* Line 787 of lalr1.cc  */
#line 525 "asm-parse.yy"
    { program_builder.add_rol((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1289 "asm-parse.cc"
    break;

  case 75:
/* Line 787 of lalr1.cc  */
#line 530 "asm-parse.yy"
    { program_builder.add_rol((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1300 "asm-parse.cc"
    break;

  case 76:
/* Line 787 of lalr1.cc  */
#line 535 "asm-parse.yy"
    { program_builder.add_rol((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1310 "asm-parse.cc"
    break;

  case 77:
/* Line 787 of lalr1.cc  */
#line 539 "asm-parse.yy"
    { program_builder.add_ror((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1322 "asm-parse.cc"
    break;

  case 78:
/* Line 787 of lalr1.cc  */
#line 545 "asm-parse.yy"
    { program_builder.add_ror((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1333 "asm-parse.cc"
    break;

  case 79:
/* Line 787 of lalr1.cc  */
#line 550 "asm-parse.yy"
    { program_builder.add_ror((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1344 "asm-parse.cc"
    break;

  case 80:
/* Line 787 of lalr1.cc  */
#line 555 "asm-parse.yy"
    { program_builder.add_ror((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1354 "asm-parse.cc"
    break;

  case 81:
/* Line 787 of lalr1.cc  */
#line 559 "asm-parse.yy"
    { program_builder.add_and((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1366 "asm-parse.cc"
    break;

  case 82:
/* Line 787 of lalr1.cc  */
#line 565 "asm-parse.yy"
    { program_builder.add_and((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1377 "asm-parse.cc"
    break;

  case 83:
/* Line 787 of lalr1.cc  */
#line 570 "asm-parse.yy"
    { program_builder.add_andi((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1388 "asm-parse.cc"
    break;

  case 84:
/* Line 787 of lalr1.cc  */
#line 575 "asm-parse.yy"
    { program_builder.add_andi((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1398 "asm-parse.cc"
    break;

  case 85:
/* Line 787 of lalr1.cc  */
#line 579 "asm-parse.yy"
    { program_builder.add_andi((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1409 "asm-parse.cc"
    break;

  case 86:
/* Line 787 of lalr1.cc  */
#line 584 "asm-parse.yy"
    { program_builder.add_andi((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1419 "asm-parse.cc"
    break;

  case 87:
/* Line 787 of lalr1.cc  */
#line 588 "asm-parse.yy"
    { program_builder.add_or((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1431 "asm-parse.cc"
    break;

  case 88:
/* Line 787 of lalr1.cc  */
#line 594 "asm-parse.yy"
    { program_builder.add_or((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1442 "asm-parse.cc"
    break;

  case 89:
/* Line 787 of lalr1.cc  */
#line 599 "asm-parse.yy"
    { program_builder.add_ori((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1453 "asm-parse.cc"
    break;

  case 90:
/* Line 787 of lalr1.cc  */
#line 604 "asm-parse.yy"
    { program_builder.add_ori((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1463 "asm-parse.cc"
    break;

  case 91:
/* Line 787 of lalr1.cc  */
#line 608 "asm-parse.yy"
    { program_builder.add_ori((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1474 "asm-parse.cc"
    break;

  case 92:
/* Line 787 of lalr1.cc  */
#line 613 "asm-parse.yy"
    { program_builder.add_ori((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1484 "asm-parse.cc"
    break;

  case 93:
/* Line 787 of lalr1.cc  */
#line 617 "asm-parse.yy"
    { program_builder.add_xor((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1496 "asm-parse.cc"
    break;

  case 94:
/* Line 787 of lalr1.cc  */
#line 623 "asm-parse.yy"
    { program_builder.add_xor((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1507 "asm-parse.cc"
    break;

  case 95:
/* Line 787 of lalr1.cc  */
#line 628 "asm-parse.yy"
    { program_builder.add_xori((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1518 "asm-parse.cc"
    break;

  case 96:
/* Line 787 of lalr1.cc  */
#line 633 "asm-parse.yy"
    { program_builder.add_xori((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1528 "asm-parse.cc"
    break;

  case 97:
/* Line 787 of lalr1.cc  */
#line 637 "asm-parse.yy"
    { program_builder.add_xori((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1539 "asm-parse.cc"
    break;

  case 98:
/* Line 787 of lalr1.cc  */
#line 642 "asm-parse.yy"
    { program_builder.add_xori((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1549 "asm-parse.cc"
    break;

  case 99:
/* Line 787 of lalr1.cc  */
#line 646 "asm-parse.yy"
    { program_builder.add_nor((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1561 "asm-parse.cc"
    break;

  case 100:
/* Line 787 of lalr1.cc  */
#line 652 "asm-parse.yy"
    { program_builder.add_nor((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1572 "asm-parse.cc"
    break;

  case 101:
/* Line 787 of lalr1.cc  */
#line 657 "asm-parse.yy"
    { program_builder.add_nor((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1583 "asm-parse.cc"
    break;

  case 102:
/* Line 787 of lalr1.cc  */
#line 662 "asm-parse.yy"
    { program_builder.add_nor((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1593 "asm-parse.cc"
    break;

  case 103:
/* Line 787 of lalr1.cc  */
#line 666 "asm-parse.yy"
    { program_builder.add_nor((yystack_[2].value.reg), (yystack_[0].value.reg), new Register(Register::general, Cpu::zero));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1604 "asm-parse.cc"
    break;

  case 104:
/* Line 787 of lalr1.cc  */
#line 671 "asm-parse.yy"
    { program_builder.add_nor((yystack_[0].value.reg), (yystack_[0].value.reg), new Register(Register::general, Cpu::zero));
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1614 "asm-parse.cc"
    break;

  case 105:
/* Line 787 of lalr1.cc  */
#line 675 "asm-parse.yy"
    { program_builder.add_seq((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1626 "asm-parse.cc"
    break;

  case 106:
/* Line 787 of lalr1.cc  */
#line 681 "asm-parse.yy"
    { program_builder.add_seq((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1637 "asm-parse.cc"
    break;

  case 107:
/* Line 787 of lalr1.cc  */
#line 686 "asm-parse.yy"
    { program_builder.add_seq((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1648 "asm-parse.cc"
    break;

  case 108:
/* Line 787 of lalr1.cc  */
#line 691 "asm-parse.yy"
    { program_builder.add_seq((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1658 "asm-parse.cc"
    break;

  case 109:
/* Line 787 of lalr1.cc  */
#line 695 "asm-parse.yy"
    { program_builder.add_sne((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1670 "asm-parse.cc"
    break;

  case 110:
/* Line 787 of lalr1.cc  */
#line 701 "asm-parse.yy"
    { program_builder.add_sne((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1681 "asm-parse.cc"
    break;

  case 111:
/* Line 787 of lalr1.cc  */
#line 706 "asm-parse.yy"
    { program_builder.add_sne((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1692 "asm-parse.cc"
    break;

  case 112:
/* Line 787 of lalr1.cc  */
#line 711 "asm-parse.yy"
    { program_builder.add_sne((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1702 "asm-parse.cc"
    break;

  case 113:
/* Line 787 of lalr1.cc  */
#line 715 "asm-parse.yy"
    { program_builder.add_sge((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1714 "asm-parse.cc"
    break;

  case 114:
/* Line 787 of lalr1.cc  */
#line 721 "asm-parse.yy"
    { program_builder.add_sge((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1725 "asm-parse.cc"
    break;

  case 115:
/* Line 787 of lalr1.cc  */
#line 726 "asm-parse.yy"
    { program_builder.add_sge((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1736 "asm-parse.cc"
    break;

  case 116:
/* Line 787 of lalr1.cc  */
#line 731 "asm-parse.yy"
    { program_builder.add_sge((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1746 "asm-parse.cc"
    break;

  case 117:
/* Line 787 of lalr1.cc  */
#line 735 "asm-parse.yy"
    { program_builder.add_sgeu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1758 "asm-parse.cc"
    break;

  case 118:
/* Line 787 of lalr1.cc  */
#line 741 "asm-parse.yy"
    { program_builder.add_sgeu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1769 "asm-parse.cc"
    break;

  case 119:
/* Line 787 of lalr1.cc  */
#line 746 "asm-parse.yy"
    { program_builder.add_sgeu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1780 "asm-parse.cc"
    break;

  case 120:
/* Line 787 of lalr1.cc  */
#line 751 "asm-parse.yy"
    { program_builder.add_sgeu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1790 "asm-parse.cc"
    break;

  case 121:
/* Line 787 of lalr1.cc  */
#line 755 "asm-parse.yy"
    { program_builder.add_slt((yystack_[4].value.reg), (yystack_[0].value.reg), (yystack_[2].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[0].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1802 "asm-parse.cc"
    break;

  case 122:
/* Line 787 of lalr1.cc  */
#line 761 "asm-parse.yy"
    { program_builder.add_sgt((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1813 "asm-parse.cc"
    break;

  case 123:
/* Line 787 of lalr1.cc  */
#line 766 "asm-parse.yy"
    { program_builder.add_sgt((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1823 "asm-parse.cc"
    break;

  case 124:
/* Line 787 of lalr1.cc  */
#line 770 "asm-parse.yy"
    { program_builder.add_sltu((yystack_[4].value.reg), (yystack_[0].value.reg), (yystack_[2].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[0].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1835 "asm-parse.cc"
    break;

  case 125:
/* Line 787 of lalr1.cc  */
#line 776 "asm-parse.yy"
    { program_builder.add_sgtu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1846 "asm-parse.cc"
    break;

  case 126:
/* Line 787 of lalr1.cc  */
#line 781 "asm-parse.yy"
    { program_builder.add_sgtu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1856 "asm-parse.cc"
    break;

  case 127:
/* Line 787 of lalr1.cc  */
#line 785 "asm-parse.yy"
    { program_builder.add_sle((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1868 "asm-parse.cc"
    break;

  case 128:
/* Line 787 of lalr1.cc  */
#line 791 "asm-parse.yy"
    { program_builder.add_sle((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1879 "asm-parse.cc"
    break;

  case 129:
/* Line 787 of lalr1.cc  */
#line 796 "asm-parse.yy"
    { program_builder.add_sle((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1890 "asm-parse.cc"
    break;

  case 130:
/* Line 787 of lalr1.cc  */
#line 801 "asm-parse.yy"
    { program_builder.add_sle((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1900 "asm-parse.cc"
    break;

  case 131:
/* Line 787 of lalr1.cc  */
#line 805 "asm-parse.yy"
    { program_builder.add_sleu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1912 "asm-parse.cc"
    break;

  case 132:
/* Line 787 of lalr1.cc  */
#line 811 "asm-parse.yy"
    { program_builder.add_sleu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1923 "asm-parse.cc"
    break;

  case 133:
/* Line 787 of lalr1.cc  */
#line 816 "asm-parse.yy"
    { program_builder.add_sleu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1934 "asm-parse.cc"
    break;

  case 134:
/* Line 787 of lalr1.cc  */
#line 821 "asm-parse.yy"
    { program_builder.add_sleu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1944 "asm-parse.cc"
    break;

  case 135:
/* Line 787 of lalr1.cc  */
#line 825 "asm-parse.yy"
    { program_builder.add_slt((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1956 "asm-parse.cc"
    break;

  case 136:
/* Line 787 of lalr1.cc  */
#line 831 "asm-parse.yy"
    { program_builder.add_slt((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1967 "asm-parse.cc"
    break;

  case 137:
/* Line 787 of lalr1.cc  */
#line 836 "asm-parse.yy"
    { program_builder.add_slti((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1978 "asm-parse.cc"
    break;

  case 138:
/* Line 787 of lalr1.cc  */
#line 841 "asm-parse.yy"
    { program_builder.add_slti((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 1988 "asm-parse.cc"
    break;

  case 139:
/* Line 787 of lalr1.cc  */
#line 845 "asm-parse.yy"
    { program_builder.add_sltu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2000 "asm-parse.cc"
    break;

  case 140:
/* Line 787 of lalr1.cc  */
#line 851 "asm-parse.yy"
    { program_builder.add_sltu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2011 "asm-parse.cc"
    break;

  case 141:
/* Line 787 of lalr1.cc  */
#line 856 "asm-parse.yy"
    { program_builder.add_sltiu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2022 "asm-parse.cc"
    break;

  case 142:
/* Line 787 of lalr1.cc  */
#line 861 "asm-parse.yy"
    { program_builder.add_sltiu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2032 "asm-parse.cc"
    break;

  case 143:
/* Line 787 of lalr1.cc  */
#line 865 "asm-parse.yy"
    { program_builder.add_slti((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2043 "asm-parse.cc"
    break;

  case 144:
/* Line 787 of lalr1.cc  */
#line 870 "asm-parse.yy"
    { program_builder.add_slti((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2053 "asm-parse.cc"
    break;

  case 145:
/* Line 787 of lalr1.cc  */
#line 874 "asm-parse.yy"
    { program_builder.add_sltiu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2064 "asm-parse.cc"
    break;

  case 146:
/* Line 787 of lalr1.cc  */
#line 879 "asm-parse.yy"
    { program_builder.add_sltiu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2074 "asm-parse.cc"
    break;

  case 147:
/* Line 787 of lalr1.cc  */
#line 883 "asm-parse.yy"
    { program_builder.add_beq((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2085 "asm-parse.cc"
    break;

  case 148:
/* Line 787 of lalr1.cc  */
#line 888 "asm-parse.yy"
    { program_builder.add_beq((yystack_[4].value.reg), (yystack_[2].value.exp), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2095 "asm-parse.cc"
    break;

  case 149:
/* Line 787 of lalr1.cc  */
#line 892 "asm-parse.yy"
    { program_builder.add_beq((yystack_[2].value.reg), new Register(Register::general, Cpu::zero), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2105 "asm-parse.cc"
    break;

  case 150:
/* Line 787 of lalr1.cc  */
#line 896 "asm-parse.yy"
    { program_builder.add_bne((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2116 "asm-parse.cc"
    break;

  case 151:
/* Line 787 of lalr1.cc  */
#line 901 "asm-parse.yy"
    { program_builder.add_bne((yystack_[4].value.reg), (yystack_[2].value.exp), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2126 "asm-parse.cc"
    break;

  case 152:
/* Line 787 of lalr1.cc  */
#line 905 "asm-parse.yy"
    { program_builder.add_bne((yystack_[2].value.reg), new Register(Register::general, Cpu::zero), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2136 "asm-parse.cc"
    break;

  case 153:
/* Line 787 of lalr1.cc  */
#line 909 "asm-parse.yy"
    { program_builder.add_bge((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2147 "asm-parse.cc"
    break;

  case 154:
/* Line 787 of lalr1.cc  */
#line 914 "asm-parse.yy"
    { program_builder.add_bge((yystack_[4].value.reg), (yystack_[2].value.exp), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2157 "asm-parse.cc"
    break;

  case 155:
/* Line 787 of lalr1.cc  */
#line 918 "asm-parse.yy"
    { program_builder.add_bgeu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2168 "asm-parse.cc"
    break;

  case 156:
/* Line 787 of lalr1.cc  */
#line 923 "asm-parse.yy"
    { program_builder.add_bgeu((yystack_[4].value.reg), (yystack_[2].value.exp), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2178 "asm-parse.cc"
    break;

  case 157:
/* Line 787 of lalr1.cc  */
#line 927 "asm-parse.yy"
    { program_builder.add_bgez((yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2188 "asm-parse.cc"
    break;

  case 158:
/* Line 787 of lalr1.cc  */
#line 931 "asm-parse.yy"
    { program_builder.add_bgezal((yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2198 "asm-parse.cc"
    break;

  case 159:
/* Line 787 of lalr1.cc  */
#line 935 "asm-parse.yy"
    { program_builder.add_bgt((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2209 "asm-parse.cc"
    break;

  case 160:
/* Line 787 of lalr1.cc  */
#line 940 "asm-parse.yy"
    { program_builder.add_bgt((yystack_[4].value.reg), (yystack_[2].value.exp), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2219 "asm-parse.cc"
    break;

  case 161:
/* Line 787 of lalr1.cc  */
#line 944 "asm-parse.yy"
    { program_builder.add_bgtu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2230 "asm-parse.cc"
    break;

  case 162:
/* Line 787 of lalr1.cc  */
#line 949 "asm-parse.yy"
    { program_builder.add_bgtu((yystack_[4].value.reg), (yystack_[2].value.exp), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2240 "asm-parse.cc"
    break;

  case 163:
/* Line 787 of lalr1.cc  */
#line 953 "asm-parse.yy"
    { program_builder.add_bgtz((yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2250 "asm-parse.cc"
    break;

  case 164:
/* Line 787 of lalr1.cc  */
#line 957 "asm-parse.yy"
    { program_builder.add_ble((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2261 "asm-parse.cc"
    break;

  case 165:
/* Line 787 of lalr1.cc  */
#line 962 "asm-parse.yy"
    { program_builder.add_ble((yystack_[4].value.reg), (yystack_[2].value.exp), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2271 "asm-parse.cc"
    break;

  case 166:
/* Line 787 of lalr1.cc  */
#line 966 "asm-parse.yy"
    { program_builder.add_bleu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2282 "asm-parse.cc"
    break;

  case 167:
/* Line 787 of lalr1.cc  */
#line 971 "asm-parse.yy"
    { program_builder.add_bleu((yystack_[4].value.reg), (yystack_[2].value.exp), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2292 "asm-parse.cc"
    break;

  case 168:
/* Line 787 of lalr1.cc  */
#line 975 "asm-parse.yy"
    { program_builder.add_blez((yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2302 "asm-parse.cc"
    break;

  case 169:
/* Line 787 of lalr1.cc  */
#line 979 "asm-parse.yy"
    { program_builder.add_blt((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2313 "asm-parse.cc"
    break;

  case 170:
/* Line 787 of lalr1.cc  */
#line 984 "asm-parse.yy"
    { program_builder.add_blt((yystack_[4].value.reg), (yystack_[2].value.exp), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2323 "asm-parse.cc"
    break;

  case 171:
/* Line 787 of lalr1.cc  */
#line 988 "asm-parse.yy"
    { program_builder.add_bltu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2334 "asm-parse.cc"
    break;

  case 172:
/* Line 787 of lalr1.cc  */
#line 993 "asm-parse.yy"
    { program_builder.add_bltu((yystack_[4].value.reg), (yystack_[2].value.exp), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2344 "asm-parse.cc"
    break;

  case 173:
/* Line 787 of lalr1.cc  */
#line 997 "asm-parse.yy"
    { program_builder.add_bltz((yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2354 "asm-parse.cc"
    break;

  case 174:
/* Line 787 of lalr1.cc  */
#line 1001 "asm-parse.yy"
    { program_builder.add_bltzal((yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2364 "asm-parse.cc"
    break;

  case 175:
/* Line 787 of lalr1.cc  */
#line 1005 "asm-parse.yy"
    { program_builder.add_j((yystack_[0].value.exp));
}
/* Line 787 of lalr1.cc  */
#line 2373 "asm-parse.cc"
    break;

  case 176:
/* Line 787 of lalr1.cc  */
#line 1008 "asm-parse.yy"
    { program_builder.add_jal((yystack_[0].value.exp));
}
/* Line 787 of lalr1.cc  */
#line 2382 "asm-parse.cc"
    break;

  case 177:
/* Line 787 of lalr1.cc  */
#line 1011 "asm-parse.yy"
    { program_builder.add_jr((yystack_[0].value.reg));
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2392 "asm-parse.cc"
    break;

  case 178:
/* Line 787 of lalr1.cc  */
#line 1015 "asm-parse.yy"
    { program_builder.add_jalr((yystack_[0].value.reg));
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2402 "asm-parse.cc"
    break;

  case 179:
/* Line 787 of lalr1.cc  */
#line 1019 "asm-parse.yy"
    { program_builder.add_lb((yystack_[5].value.reg), (yystack_[3].value.exp), (yystack_[1].value.reg));
  delete (yystack_[5].value.reg);
  delete (yystack_[1].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2413 "asm-parse.cc"
    break;

  case 180:
/* Line 787 of lalr1.cc  */
#line 1024 "asm-parse.yy"
    { program_builder.add_lb((yystack_[4].value.reg), new IntExp(0), (yystack_[1].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[1].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2424 "asm-parse.cc"
    break;

  case 181:
/* Line 787 of lalr1.cc  */
#line 1029 "asm-parse.yy"
    { program_builder.add_lbu((yystack_[5].value.reg), (yystack_[3].value.exp), (yystack_[1].value.reg));
  delete (yystack_[5].value.reg);
  delete (yystack_[1].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2435 "asm-parse.cc"
    break;

  case 182:
/* Line 787 of lalr1.cc  */
#line 1034 "asm-parse.yy"
    { program_builder.add_lbu((yystack_[4].value.reg), new IntExp(0), (yystack_[1].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[1].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2446 "asm-parse.cc"
    break;

  case 183:
/* Line 787 of lalr1.cc  */
#line 1039 "asm-parse.yy"
    { program_builder.add_lw((yystack_[5].value.reg), (yystack_[3].value.exp), (yystack_[1].value.reg));
  delete (yystack_[5].value.reg);
  delete (yystack_[1].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2457 "asm-parse.cc"
    break;

  case 184:
/* Line 787 of lalr1.cc  */
#line 1044 "asm-parse.yy"
    { program_builder.add_lw((yystack_[4].value.reg), new IntExp(0), (yystack_[1].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[1].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2468 "asm-parse.cc"
    break;

  case 185:
/* Line 787 of lalr1.cc  */
#line 1049 "asm-parse.yy"
    { program_builder.add_lui((yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2478 "asm-parse.cc"
    break;

  case 186:
/* Line 787 of lalr1.cc  */
#line 1053 "asm-parse.yy"
    { program_builder.add_ori((yystack_[2].value.reg), new Register(Register::general, Cpu::zero), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2488 "asm-parse.cc"
    break;

  case 187:
/* Line 787 of lalr1.cc  */
#line 1057 "asm-parse.yy"
    { program_builder.add_la((yystack_[5].value.reg), (yystack_[3].value.exp), (yystack_[1].value.reg));
  delete (yystack_[5].value.reg);
  delete (yystack_[1].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2499 "asm-parse.cc"
    break;

  case 188:
/* Line 787 of lalr1.cc  */
#line 1062 "asm-parse.yy"
    { program_builder.add_la((yystack_[4].value.reg), new IntExp(0), (yystack_[1].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[1].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2510 "asm-parse.cc"
    break;

  case 189:
/* Line 787 of lalr1.cc  */
#line 1067 "asm-parse.yy"
    { program_builder.add_la((yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2520 "asm-parse.cc"
    break;

  case 190:
/* Line 787 of lalr1.cc  */
#line 1071 "asm-parse.yy"
    { program_builder.add_sb((yystack_[5].value.reg), (yystack_[3].value.exp), (yystack_[1].value.reg));
  delete (yystack_[5].value.reg);
  delete (yystack_[1].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2531 "asm-parse.cc"
    break;

  case 191:
/* Line 787 of lalr1.cc  */
#line 1076 "asm-parse.yy"
    { program_builder.add_sb((yystack_[4].value.reg), new IntExp(0), (yystack_[1].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[1].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2542 "asm-parse.cc"
    break;

  case 192:
/* Line 787 of lalr1.cc  */
#line 1081 "asm-parse.yy"
    { program_builder.add_sw((yystack_[5].value.reg), (yystack_[3].value.exp), (yystack_[1].value.reg));
  delete (yystack_[5].value.reg);
  delete (yystack_[1].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2553 "asm-parse.cc"
    break;

  case 193:
/* Line 787 of lalr1.cc  */
#line 1086 "asm-parse.yy"
    { program_builder.add_sw((yystack_[4].value.reg), new IntExp(0), (yystack_[1].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[1].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2564 "asm-parse.cc"
    break;

  case 194:
/* Line 787 of lalr1.cc  */
#line 1091 "asm-parse.yy"
    { program_builder.add_addu((yystack_[2].value.reg), (yystack_[0].value.reg), new Register(Register::general, Cpu::zero));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2575 "asm-parse.cc"
    break;

  case 195:
/* Line 787 of lalr1.cc  */
#line 1096 "asm-parse.yy"
    { program_builder.add_mfhi((yystack_[0].value.reg));
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2585 "asm-parse.cc"
    break;

  case 196:
/* Line 787 of lalr1.cc  */
#line 1100 "asm-parse.yy"
    { program_builder.add_mflo((yystack_[0].value.reg));
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2595 "asm-parse.cc"
    break;

  case 197:
/* Line 787 of lalr1.cc  */
#line 1104 "asm-parse.yy"
    { program_builder.add_mthi((yystack_[0].value.reg));
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2605 "asm-parse.cc"
    break;

  case 198:
/* Line 787 of lalr1.cc  */
#line 1108 "asm-parse.yy"
    { program_builder.add_mtlo((yystack_[0].value.reg));
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2615 "asm-parse.cc"
    break;

  case 199:
/* Line 787 of lalr1.cc  */
#line 1112 "asm-parse.yy"
    { program_builder.add_mfc0((yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2626 "asm-parse.cc"
    break;

  case 200:
/* Line 787 of lalr1.cc  */
#line 1117 "asm-parse.yy"
    { program_builder.add_mtc0((yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
/* Line 787 of lalr1.cc  */
#line 2637 "asm-parse.cc"
    break;

  case 201:
/* Line 787 of lalr1.cc  */
#line 1122 "asm-parse.yy"
    { program_builder.add_syscall();
}
/* Line 787 of lalr1.cc  */
#line 2646 "asm-parse.cc"
    break;

  case 202:
/* Line 787 of lalr1.cc  */
#line 1125 "asm-parse.yy"
    { program_builder.add_sll(new Register(Register::general, Cpu::zero), new Register(Register::general, Cpu::zero), new IntExp(0));
}
/* Line 787 of lalr1.cc  */
#line 2655 "asm-parse.cc"
    break;

  case 203:
/* Line 787 of lalr1.cc  */
#line 1129 "asm-parse.yy"
    { (yylhs.value.exp) = new OpExp((yystack_[2].value.exp), OpExp::add, (yystack_[0].value.exp)); }
/* Line 787 of lalr1.cc  */
#line 2663 "asm-parse.cc"
    break;

  case 204:
/* Line 787 of lalr1.cc  */
#line 1130 "asm-parse.yy"
    { (yylhs.value.exp) = new OpExp((yystack_[2].value.exp), OpExp::sub, (yystack_[0].value.exp)); }
/* Line 787 of lalr1.cc  */
#line 2671 "asm-parse.cc"
    break;

  case 205:
/* Line 787 of lalr1.cc  */
#line 1131 "asm-parse.yy"
    { (yylhs.value.exp) = new OpExp((yystack_[2].value.exp), OpExp::mul, (yystack_[0].value.exp)); }
/* Line 787 of lalr1.cc  */
#line 2679 "asm-parse.cc"
    break;

  case 206:
/* Line 787 of lalr1.cc  */
#line 1132 "asm-parse.yy"
    { (yylhs.value.exp) = new OpExp((yystack_[2].value.exp), OpExp::div, (yystack_[0].value.exp)); }
/* Line 787 of lalr1.cc  */
#line 2687 "asm-parse.cc"
    break;

  case 207:
/* Line 787 of lalr1.cc  */
#line 1134 "asm-parse.yy"
    { (yylhs.value.exp) = new OpExp(new IntExp(0), OpExp::sub, (yystack_[0].value.exp)); }
/* Line 787 of lalr1.cc  */
#line 2695 "asm-parse.cc"
    break;

  case 208:
/* Line 787 of lalr1.cc  */
#line 1135 "asm-parse.yy"
    { (yylhs.value.exp) = (yystack_[1].value.exp); }
/* Line 787 of lalr1.cc  */
#line 2703 "asm-parse.cc"
    break;

  case 209:
/* Line 787 of lalr1.cc  */
#line 1136 "asm-parse.yy"
    { (yylhs.value.exp) = new IntExp((yystack_[0].value.i)); }
/* Line 787 of lalr1.cc  */
#line 2711 "asm-parse.cc"
    break;

  case 210:
/* Line 787 of lalr1.cc  */
#line 1137 "asm-parse.yy"
    { (yylhs.value.exp) = new LabelExp(*(yystack_[0].value.id)); }
/* Line 787 of lalr1.cc  */
#line 2719 "asm-parse.cc"
    break;


/* Line 787 of lalr1.cc  */
#line 2724 "asm-parse.cc"
	default:
          break;
      }
    // Compute post-reduction state.
    yyn = yyr1_[yyn];
    yystate = yypgoto_[yyn - yyntokens_] + yystack_[yylen].state;
    if (0 <= yystate && yystate <= yylast_
	&& yycheck_[yystate] == yystack_[yylen].state)
      yystate = yytable_[yystate];
    else
      yystate = yydefgoto_[yyn - yyntokens_];
    yylhs.state = yystate;
    YY_SYMBOL_PRINT ("-> $$ =", yylhs);


    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();

    /* Shift the result of the reduction.  */
    yypush_ (0, yylhs);
    goto yynewstate;

  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    /* If not already recovering from an error, report this error.  */
    if (!yyerrstatus_)
      {
	++yynerrs_;
	error (yyla.location, yysyntax_error_ (yystate, yyla.type));
      }


    yyerror_range[0].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
	/* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        /* Return failure if at end of input.  */
        if (yyla.type == yyeof_)
          YYABORT;
        else
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyempty = true;
	  }
      }

    /* Else will try to reuse lookahead token after shifting the error
       token.  */
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;


    yyerror_range[0].location = yystack_[yylen - 1].location;
    /* Do not reclaim the symbols of the rule which action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    yystate = yystack_[0].state;
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;	/* Each real token shifted decrements this.  */
    {
      stack_symbol_type error_token;
      for (;;)
        {
          yyn = yypact_[yystate];
          if (yyn != yypact_ninf_)
            {
              yyn += yyterror_;
              if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
                {
                  yyn = yytable_[yyn];
                  if (0 < yyn)
                    break;
                }
            }

          // Pop the current state because it cannot handle the error token.
          if (yystack_.size () == 1)
            YYABORT;

          yyerror_range[0].location = yystack_[0].location;
          yy_destroy_ ("Error: popping", yystack_[0]);
          yypop_ ();
          yystate = yystack_[0].state;
          YY_STACK_PRINT ();
        }

      yyerror_range[1].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, (yyerror_range - 1), 2);

      /* Shift the error token.  */
      error_token.state = yystate = yyn;
      yypush_ ("Shifting", error_token);
    }
    goto yynewstate;

    /* Accept.  */
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    /* Abort.  */
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (!yyempty)
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule which action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (yystack_.size () != 1)
      {
	yy_destroy_ ("Cleanup: popping", yystack_[0]);
	yypop_ ();
      }

    return yyresult;
  }

  // Generate an error message.
  std::string
  parser::yysyntax_error_ (int yystate, int yytoken)
  {
    std::string yyres;
    int yyn = yypact_[yystate];
    if (yypact_ninf_ < yyn && yyn <= yylast_)
      {
	/* Start YYX at -YYN if negative to avoid negative indexes in
	   YYCHECK.  */
	int yyxbegin = yyn < 0 ? -yyn : 0;

	/* Stay within bounds of both yycheck and yytname.  */
	int yychecklim = yylast_ - yyn + 1;
	int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;

        // Number of reported tokens (one for the "unexpected", one per
        // "expected").
	size_t yycount = 0;
        // Its maximum.
        enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
        // Arguments of yyformat.
        char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
        yyarg[yycount++] = yytname_[yytoken];
	for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
	  if (yycheck_[yyx + yyn] == yyx && yyx != yyterror_)
          {
            if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
            {
              yycount = 1;
              break;
            }
            else
              yyarg[yycount++] = yytname_[yyx];
          }

        char const* yyformat = 0;
        switch (yycount)
        {
#define YYCASE_(N, S)                           \
          case N:                               \
            yyformat = S;                       \
          break
          YYCASE_(1, YY_("syntax error, unexpected %s"));
          YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
          YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
          YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
          YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
        }
        // Argument number.
        size_t yyi = 0;
        for (char const* yyp = yyformat; *yyp; ++yyp)
          if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
          {
            yyres += yytnamerr_ (yyarg[yyi++]);
            ++yyp;
          }
          else
            yyres += *yyp;
      }
    else
      yyres = YY_("syntax error");
    return yyres;
  }


  const signed char parser::yypact_ninf_ = -69;

  const signed char parser::yytable_ninf_ = -1;

  const short int
  parser::yypact_[] =
  {
     -69,     6,   -69,   -69,   -69,   176,    -2,   -69,    -3,     3,
      23,    27,    30,    34,    37,    41,    44,    48,    51,    55,
      58,    62,    65,    69,    72,    76,    79,    83,    90,    93,
      97,   100,   104,   110,   111,   112,   124,   128,   130,   132,
     142,   174,   188,   275,   277,   280,   284,   287,   291,   294,
     298,   302,   308,   309,   319,   320,   322,   324,   326,   369,
     371,   374,   378,   381,   385,   388,   392,   395,   122,   122,
     399,   402,   406,   409,   413,   416,   420,   423,   427,   430,
     434,   437,   441,   444,   448,   451,   455,   -69,   -69,   -69,
     -69,   460,   464,   467,    22,   473,   480,   -69,   466,   483,
     487,   490,   494,   497,   501,   504,   508,   511,   515,   518,
     522,   525,   529,   532,   536,   539,   543,   546,   550,   553,
     557,   560,   564,   567,   571,   574,   578,   581,   585,   588,
     592,   595,   599,   602,   606,   609,   613,   616,   620,   623,
     627,   630,   634,   637,   641,   644,   648,   651,   655,   658,
     662,   665,   669,   672,   676,   679,   683,   686,   -69,   -69,
     122,   122,   831,   831,   -69,   -69,   690,   693,   697,   700,
     704,   707,   711,   714,   718,   -69,   -69,   -69,   -69,   721,
     725,   -69,   -69,   -69,   -69,   -69,   -69,   -69,     0,    21,
      28,    35,   476,   732,   735,   739,   743,   746,   750,   754,
     758,   765,    42,   766,    49,   772,    56,   773,    63,    70,
      77,    84,    91,    98,   105,   121,   278,   779,   285,   292,
     299,   372,   379,   386,   393,   400,   407,   414,   421,   428,
     435,   122,   442,   122,   449,   456,   122,   122,   463,   470,
     122,   477,   484,   122,   491,   498,   122,   122,   185,   -69,
     122,   122,   122,   122,   729,   733,   740,   122,   122,   744,
     751,   755,   780,   839,   840,   838,   831,   841,   831,   842,
     831,   843,   831,   844,   845,   -69,   -69,   -69,   846,   847,
     848,   849,   850,   851,   831,   852,   853,   831,   854,   855,
     831,   856,   857,   831,   858,   831,   859,   831,   860,   831,
     861,   831,   862,   831,   863,   831,   864,   831,   865,   831,
     -69,   866,   831,   867,   831,   868,   831,   869,   831,   870,
     831,   871,   831,   872,   831,   873,   831,   874,   831,   875,
     831,   876,   831,   877,   831,   878,   782,   831,   879,   787,
     831,   880,   792,   881,   797,   831,   831,   882,   802,   883,
     807,   831,   884,   812,   885,   817,   831,   886,   822,   887,
     827,   831,   831,   -69,   101,   101,   -69,   -69,   505,     1,
     512,   300,   519,   756,   831,   831,   526,   763,   533,   770,
     540,   777,   -69,   -69,   -69,   547,   554,   122,   122,   561,
     568,   575,   582,   589,   891,   892,   596,   893,   603,   894,
     610,   895,   617,   624,   631,   122,   638,   122,   645,   122,
     652,   659,   666,   673,   680,   687,   694,   701,   708,   715,
     722,   122,   122,   122,   122,   122,   122,   122,   122,   122,
     122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
     122,   122,   122,   481,   896,   897,   898,   899,   900,   901,
     902,   903,   904,   905,   906,   -69,   831,   -69,   831,   831,
     831,   -69,   831,   -69,   831,   -69,   831,   -69,   831,   -69,
     831,   -69,   -69,   -69,   831,   -69,   -69,   831,   -69,   -69,
     831,   -69,   -69,   831,   -69,   831,   -69,   831,   831,   -69,
     831,   831,   -69,   831,   831,   -69,   831,   -69,   831,   -69,
     831,   -69,   831,   -69,   831,   -69,   831,   -69,   831,   -69,
     831,   -69,   831,   -69,   831,   -69,   831,   831,   831,   831,
     831,   831,   831,   831,   831,   831,   831,   831,   831,   831,
     831,   831,   831,   831,   831,   831,   831,   831,   831,   -69,
     907,   -69,   908,   -69,   909,   -69,   910,   -69,   911,   -69,
     912,   -69,   -69,   -69,   -69,   -69,   -69
  };

  const unsigned char
  parser::yydefact_[] =
  {
       2,     0,     1,    15,     5,     3,     4,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   201,   202,    16,
       7,     0,     0,     0,     0,     0,     0,     6,     0,     0,
       0,     0,     0,     0,    37,    39,    41,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   104,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   210,   209,
       0,     0,   175,   176,   177,   178,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   195,   196,   197,   198,     0,
       0,     8,     9,    10,    12,    11,    13,    14,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   207,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    19,    21,    23,    25,     0,
      27,     0,    29,    31,    34,    36,    38,    40,    43,    45,
      48,    52,    54,    58,    56,    60,    64,    62,    66,    70,
      68,    72,    74,    76,    78,    80,    82,    84,     0,    86,
      88,    90,     0,    92,    94,    96,     0,    98,   100,   102,
     103,   106,   108,   110,   112,   114,   116,   118,   120,     0,
     123,     0,   126,   128,   130,   132,   134,   136,   138,   140,
     142,     0,   144,     0,   146,     0,     0,   149,     0,     0,
     152,     0,     0,     0,     0,   157,   158,     0,     0,     0,
       0,   163,     0,     0,     0,     0,   168,     0,     0,     0,
       0,   173,   174,   208,   204,   203,   206,   205,     0,     0,
       0,     0,     0,     0,   185,   186,     0,   189,     0,     0,
       0,     0,   194,   199,   200,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    18,    20,    22,    24,    26,
      28,    30,    32,    33,    35,    42,    44,    46,    47,    49,
      50,    51,    53,    57,    55,    59,    63,    61,    65,    69,
      67,    71,    73,    75,    77,    79,    81,    83,    85,    87,
      89,    91,    93,    95,    97,    99,   101,   105,   107,   109,
     111,   113,   115,   117,   119,   121,   122,   124,   125,   127,
     129,   131,   133,   135,   137,   139,   141,   143,   145,   147,
     148,   150,   151,   153,   154,   155,   156,   159,   160,   161,
     162,   164,   165,   166,   167,   169,   170,   171,   172,   180,
       0,   182,     0,   184,     0,   188,     0,   191,     0,   193,
       0,   179,   181,   183,   187,   190,   192
  };

  const signed char
  parser::yypgoto_[] =
  {
     -69,   -69,   -69,   -69,   -69,   -69,   -68
  };

  const short int
  parser::yydefgoto_[] =
  {
      -1,     1,     6,    97,     5,    89,   248
  };

  const unsigned short int
  parser::yytable_[] =
  {
     162,   163,    90,   158,    98,   159,     2,   265,   160,   444,
      99,   161,   250,   251,   252,   253,    91,    92,    93,    94,
      95,    96,     3,     4,   158,   184,   159,   185,   267,   160,
     100,   158,   161,   159,   101,   269,   160,   102,   158,   161,
     159,   103,   271,   160,   104,   158,   161,   159,   105,   283,
     160,   106,   158,   161,   159,   107,   286,   160,   108,   158,
     161,   159,   109,   289,   160,   110,   158,   161,   159,   111,
     292,   160,   112,   158,   161,   159,   113,   294,   160,   114,
     158,   161,   159,   115,   296,   160,   116,   158,   161,   159,
     117,   298,   160,   249,   158,   161,   159,   118,   300,   160,
     119,   158,   161,   159,   120,   302,   160,   121,   158,   161,
     159,   122,   304,   160,   252,   253,   161,   123,   124,   125,
     266,   268,   270,   272,   158,   158,   159,   159,   306,   160,
     160,   126,   161,   161,   284,   127,   287,   128,   290,   129,
     293,   295,   297,   299,   301,   303,   305,   307,   309,   130,
     312,   314,   316,   318,   320,   322,   324,   326,   328,   330,
     332,   334,   336,   337,   339,   340,   342,   344,   345,   346,
     348,   350,   351,   353,   355,   356,   358,   360,   361,   362,
       7,   131,   364,   365,   366,   367,   369,   371,   373,   374,
     375,   377,   379,   381,   363,   132,   250,   251,   252,   253,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,   158,   133,   159,   134,   308,   160,   135,   158,   161,
     159,   136,   311,   160,   137,   158,   161,   159,   138,   313,
     160,   139,   158,   161,   159,   140,   315,   160,   446,   141,
     161,   250,   251,   252,   253,   142,   143,   456,   458,   459,
     460,   462,   464,   466,   468,   470,   144,   145,   474,   146,
     477,   147,   480,   148,   483,   485,   487,   488,   490,   491,
     493,   494,   496,   498,   500,   502,   504,   506,   508,   510,
     512,   514,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   158,   149,   159,   150,   317,
     160,   151,   158,   161,   159,   152,   319,   160,   153,   158,
     161,   159,   154,   321,   160,   155,   158,   161,   159,   156,
     323,   160,   157,   158,   161,   159,   164,   325,   160,   165,
     158,   161,   159,   166,   327,   160,   167,   158,   161,   159,
     168,   329,   160,   169,   158,   161,   159,   170,   331,   160,
     171,   158,   161,   159,   172,   333,   160,   173,   158,   161,
     159,   174,   335,   160,   175,   158,   161,   159,   176,   338,
     160,   177,   158,   161,   159,   178,   341,   160,   179,   158,
     161,   159,   180,   343,   160,   181,   158,   161,   159,   182,
     347,   160,   183,   158,   161,   159,   188,   349,   160,   186,
     158,   161,   159,   273,   352,   160,   187,   158,   161,   159,
     539,   354,   160,   189,   158,   161,   159,   190,   357,   160,
     191,   158,   161,   159,   192,   359,   160,   193,   158,   161,
     159,   194,   443,   160,   195,   158,   161,   159,   196,   445,
     160,   197,   158,   161,   159,   198,   447,   160,   199,   158,
     161,   159,   200,   449,   160,   201,   158,   161,   159,   202,
     451,   160,   203,   158,   161,   159,   204,   453,   160,   205,
     158,   161,   159,   206,   455,   160,   207,   158,   161,   159,
     208,   457,   160,   209,   158,   161,   159,   210,   461,   160,
     211,   158,   161,   159,   212,   463,   160,   213,   158,   161,
     159,   214,   465,   160,   215,   158,   161,   159,   216,   467,
     160,   217,   158,   161,   159,   218,   469,   160,   219,   158,
     161,   159,   220,   473,   160,   221,   158,   161,   159,   222,
     476,   160,   223,   158,   161,   159,   224,   479,   160,   225,
     158,   161,   159,   226,   482,   160,   227,   158,   161,   159,
     228,   484,   160,   229,   158,   161,   159,   230,   486,   160,
     231,   158,   161,   159,   232,   489,   160,   233,   158,   161,
     159,   234,   492,   160,   235,   158,   161,   159,   236,   495,
     160,   237,   158,   161,   159,   238,   497,   160,   239,   158,
     161,   159,   240,   499,   160,   241,   158,   161,   159,   242,
     501,   160,   243,   158,   161,   159,   244,   503,   160,   245,
     158,   161,   159,   246,   505,   160,   247,   158,   161,   159,
     254,   507,   160,   255,   158,   161,   159,   256,   509,   160,
     257,   158,   161,   159,   258,   511,   160,   259,   158,   161,
     159,   260,   513,   160,   261,   158,   161,   159,   262,   515,
     160,   263,   158,   161,   159,   264,   158,   368,   159,   274,
     161,   370,   275,   158,   161,   159,   276,   158,   372,   159,
     277,   161,   376,   278,   158,   161,   159,   279,   158,   378,
     159,   280,   161,   380,   448,   281,   161,   250,   251,   252,
     253,   450,   282,   285,   250,   251,   252,   253,   452,   288,
     291,   250,   251,   252,   253,   454,   310,   382,   250,   251,
     252,   253,   424,   250,   251,   252,   253,   426,   250,   251,
     252,   253,   428,   250,   251,   252,   253,   430,   250,   251,
     252,   253,   432,   250,   251,   252,   253,   434,   250,   251,
     252,   253,   436,   250,   251,   252,   253,   438,   250,   251,
     252,   253,   440,   250,   251,   252,   253,   442,   250,   251,
     252,   253,   250,   251,   252,   253,   383,   384,   385,     0,
       0,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   425,
     427,   429,   431,   433,   435,   437,   439,   441,   471,   472,
     475,   478,   481,   540,     0,   542,   541,   544,   543,   546,
     545,   548,   547,   550,   549,     0,   551,   552,   553,   554,
     555,   556
  };

  const short int
  parser::yycheck_[] =
  {
      68,    69,     4,     3,     7,     5,     0,     7,     8,     8,
       7,    11,    11,    12,    13,    14,    18,    19,    20,    21,
      22,    23,    16,    17,     3,     3,     5,     5,     7,     8,
       7,     3,    11,     5,     7,     7,     8,     7,     3,    11,
       5,     7,     7,     8,     7,     3,    11,     5,     7,     7,
       8,     7,     3,    11,     5,     7,     7,     8,     7,     3,
      11,     5,     7,     7,     8,     7,     3,    11,     5,     7,
       7,     8,     7,     3,    11,     5,     7,     7,     8,     7,
       3,    11,     5,     7,     7,     8,     7,     3,    11,     5,
       7,     7,     8,   161,     3,    11,     5,     7,     7,     8,
       7,     3,    11,     5,     7,     7,     8,     7,     3,    11,
       5,     7,     7,     8,    13,    14,    11,     7,     7,     7,
     188,   189,   190,   191,     3,     3,     5,     5,     7,     8,
       8,     7,    11,    11,   202,     7,   204,     7,   206,     7,
     208,   209,   210,   211,   212,   213,   214,   215,   216,     7,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
       4,     7,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     9,     7,    11,    12,    13,    14,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,     3,     7,     5,     7,     7,     8,     7,     3,    11,
       5,     7,     7,     8,     7,     3,    11,     5,     7,     7,
       8,     7,     3,    11,     5,     7,     7,     8,     8,     7,
      11,    11,    12,    13,    14,     7,     7,   385,   386,   387,
     388,   389,   390,   391,   392,   393,     7,     7,   396,     7,
     398,     7,   400,     7,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,     3,     7,     5,     7,     7,
       8,     7,     3,    11,     5,     7,     7,     8,     7,     3,
      11,     5,     7,     7,     8,     7,     3,    11,     5,     7,
       7,     8,     7,     3,    11,     5,     7,     7,     8,     7,
       3,    11,     5,     7,     7,     8,     7,     3,    11,     5,
       7,     7,     8,     7,     3,    11,     5,     7,     7,     8,
       7,     3,    11,     5,     7,     7,     8,     7,     3,    11,
       5,     7,     7,     8,     7,     3,    11,     5,     7,     7,
       8,     7,     3,    11,     5,     7,     7,     8,     7,     3,
      11,     5,     7,     7,     8,     5,     3,    11,     5,     5,
       7,     8,     5,     3,    11,     5,    10,     7,     8,     6,
       3,    11,     5,     7,     7,     8,     6,     3,    11,     5,
       9,     7,     8,    10,     3,    11,     5,    10,     7,     8,
      10,     3,    11,     5,    10,     7,     8,    10,     3,    11,
       5,    10,     7,     8,    10,     3,    11,     5,    10,     7,
       8,    10,     3,    11,     5,    10,     7,     8,    10,     3,
      11,     5,    10,     7,     8,    10,     3,    11,     5,    10,
       7,     8,    10,     3,    11,     5,    10,     7,     8,    10,
       3,    11,     5,    10,     7,     8,    10,     3,    11,     5,
      10,     7,     8,    10,     3,    11,     5,    10,     7,     8,
      10,     3,    11,     5,    10,     7,     8,    10,     3,    11,
       5,    10,     7,     8,    10,     3,    11,     5,    10,     7,
       8,    10,     3,    11,     5,    10,     7,     8,    10,     3,
      11,     5,    10,     7,     8,    10,     3,    11,     5,    10,
       7,     8,    10,     3,    11,     5,    10,     7,     8,    10,
       3,    11,     5,    10,     7,     8,    10,     3,    11,     5,
      10,     7,     8,    10,     3,    11,     5,    10,     7,     8,
      10,     3,    11,     5,    10,     7,     8,    10,     3,    11,
       5,    10,     7,     8,    10,     3,    11,     5,    10,     7,
       8,    10,     3,    11,     5,    10,     7,     8,    10,     3,
      11,     5,    10,     7,     8,    10,     3,    11,     5,    10,
       7,     8,    10,     3,    11,     5,    10,     7,     8,    10,
       3,    11,     5,    10,     7,     8,    10,     3,    11,     5,
      10,     7,     8,    10,     3,    11,     5,    10,     7,     8,
      10,     3,    11,     5,    10,     7,     8,    10,     3,    11,
       5,    10,     7,     8,    10,     3,    11,     5,    10,     7,
       8,    10,     3,    11,     5,    10,     3,     8,     5,     7,
      11,     8,     7,     3,    11,     5,     7,     3,     8,     5,
       7,    11,     8,     7,     3,    11,     5,     7,     3,     8,
       5,     7,    11,     8,     8,     7,    11,    11,    12,    13,
      14,     8,     7,     7,    11,    12,    13,    14,     8,     7,
       7,    11,    12,    13,    14,     8,     7,     7,    11,    12,
      13,    14,    10,    11,    12,    13,    14,    10,    11,    12,
      13,    14,    10,    11,    12,    13,    14,    10,    11,    12,
      13,    14,    10,    11,    12,    13,    14,    10,    11,    12,
      13,    14,    10,    11,    12,    13,    14,    10,    11,    12,
      13,    14,    10,    11,    12,    13,    14,    10,    11,    12,
      13,    14,    11,    12,    13,    14,     7,     7,    10,    -1,
      -1,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,     7,     7,
       7,     7,     7,     7,    -1,     7,     9,     7,     9,     7,
       9,     7,     9,     7,     9,    -1,     9,     9,     9,     9,
       9,     9
  };

  const unsigned char
  parser::yystos_[] =
  {
       0,   106,     0,    16,    17,   109,   107,     4,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   110,
       4,    18,    19,    20,    21,    22,    23,   108,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     3,     5,
       8,    11,   111,   111,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     5,     5,     5,     3,     5,     6,     6,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,   111,   111,
      11,    12,    13,    14,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,     7,   111,     7,   111,     7,
     111,     7,   111,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,   111,     7,     7,   111,     7,     7,
     111,     7,     7,   111,     7,   111,     7,   111,     7,   111,
       7,   111,     7,   111,     7,   111,     7,   111,     7,   111,
       7,     7,   111,     7,   111,     7,   111,     7,   111,     7,
     111,     7,   111,     7,   111,     7,   111,     7,   111,     7,
     111,     7,   111,     7,   111,     7,   111,   111,     7,   111,
     111,     7,   111,     7,   111,   111,   111,     7,   111,     7,
     111,   111,     7,   111,     7,   111,   111,     7,   111,     7,
     111,   111,   111,     9,   111,   111,   111,   111,     8,   111,
       8,   111,     8,   111,   111,   111,     8,   111,     8,   111,
       8,   111,     7,     7,     7,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,     7,     8,     7,     8,     7,     8,     7,
       8,     7,     8,     7,     8,     7,   111,     7,   111,   111,
     111,     7,   111,     7,   111,     7,   111,     7,   111,     7,
     111,     7,     7,     7,   111,     7,     7,   111,     7,     7,
     111,     7,     7,   111,     7,   111,     7,   111,   111,     7,
     111,   111,     7,   111,   111,     7,   111,     7,   111,     7,
     111,     7,   111,     7,   111,     7,   111,     7,   111,     7,
     111,     7,   111,     7,   111,     7,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,     9,
       7,     9,     7,     9,     7,     9,     7,     9,     7,     9,
       7,     9,     9,     9,     9,     9,     9
  };

  const unsigned char
  parser::yyr1_[] =
  {
       0,   105,   106,   106,   106,   107,   107,   108,   108,   108,
     108,   108,   108,   108,   108,   109,   109,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   111,   111,   111,   111,   111,   111,   111,
     111
  };

  const unsigned char
  parser::yyr2_[] =
  {
       0,     2,     0,     3,     3,     0,     2,     1,     2,     2,
       2,     2,     2,     2,     2,     0,     2,     1,     6,     4,
       6,     4,     6,     4,     6,     4,     6,     4,     6,     4,
       6,     4,     6,     6,     4,     6,     4,     2,     4,     2,
       4,     2,     6,     4,     6,     4,     6,     6,     4,     6,
       6,     6,     4,     6,     4,     6,     4,     6,     4,     6,
       4,     6,     4,     6,     4,     6,     4,     6,     4,     6,
       4,     6,     4,     6,     4,     6,     4,     6,     4,     6,
       4,     6,     4,     6,     4,     6,     4,     6,     4,     6,
       4,     6,     4,     6,     4,     6,     4,     6,     4,     6,
       4,     6,     4,     4,     2,     6,     4,     6,     4,     6,
       4,     6,     4,     6,     4,     6,     4,     6,     4,     6,
       4,     6,     6,     4,     6,     6,     4,     6,     4,     6,
       4,     6,     4,     6,     4,     6,     4,     6,     4,     6,
       4,     6,     4,     6,     4,     6,     4,     6,     6,     4,
       6,     6,     4,     6,     6,     6,     6,     4,     4,     6,
       6,     6,     6,     4,     6,     6,     6,     6,     4,     6,
       6,     6,     6,     4,     4,     2,     2,     2,     2,     7,
       6,     7,     6,     7,     6,     4,     4,     7,     6,     4,
       7,     6,     7,     6,     4,     2,     2,     2,     2,     4,
       4,     1,     1,     3,     3,     3,     3,     2,     3,     1,
       1
  };


#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
  /* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
     First, the terminals, then, starting at \a yyntokens_, nonterminals.  */
  const char*
  const parser::yytname_[] =
  {
  "\"end of file\"", "error", "$undefined", "\"label\"",
  "\"label definition\"", "\"integer\"", "\"string\"", "\"register\"",
  "\"(\"", "\")\"", "\",\"", "EXP_SUB", "EXP_ADD", "EXP_DIV", "EXP_MUL",
  "EXP_UMINUS", "\".text\"", "\".data\"", "\".space\"", "\".byte\"",
  "\".half\"", "\".word\"", "\".ascii\"", "\".asciiz\"", "\"add\"",
  "\"addu\"", "\"addi\"", "\"addiu\"", "\"sub\"", "\"subu\"", "\"neg\"",
  "\"negu\"", "\"abs\"", "\"mul\"", "\"div\"", "\"divu\"", "\"rem\"",
  "\"remu\"", "\"sll\"", "\"sllv\"", "\"sra\"", "\"srav\"", "\"srl\"",
  "\"srlv\"", "\"rol\"", "\"ror\"", "\"and\"", "\"andi\"", "\"or\"",
  "\"ori\"", "\"xor\"", "\"xori\"", "\"nor\"", "\"not\"", "\"seq\"",
  "\"sne\"", "\"sge\"", "\"sgeu\"", "\"sgt\"", "\"sgtu\"", "\"sle\"",
  "\"sleu\"", "\"slt\"", "\"sltu\"", "\"slti\"", "\"sltiu\"", "\"beq\"",
  "\"beqz\"", "\"bne\"", "\"bnez\"", "\"bge\"", "\"bgeu\"", "\"bgez\"",
  "\"bgezal\"", "\"bgt\"", "\"bgtu\"", "\"bgtz\"", "\"ble\"", "\"bleu\"",
  "\"blez\"", "\"blt\"", "\"bltu\"", "\"bltz\"", "\"bltzal\"", "\"j\"",
  "\"jal\"", "\"jr\"", "\"jalr\"", "\"lb\"", "\"lbu\"", "\"lw\"",
  "\"lui\"", "\"li\"", "\"la\"", "\"sb\"", "\"sw\"", "\"move\"",
  "\"mfhi\"", "\"mflo\"", "\"mthi\"", "\"mtlo\"", "\"mfc0\"", "\"mtc0\"",
  "\"syscall\"", "\"nop\"", "$accept", "program", "datas", "data",
  "instructions", "instruction", "exp", 0
  };
#endif

#if YYDEBUG
  const unsigned short int
  parser::yyrline_[] =
  {
       0,   190,   190,   192,   193,   197,   199,   203,   207,   211,
     214,   217,   219,   222,   224,   228,   230,   234,   238,   244,
     249,   254,   258,   264,   269,   274,   278,   283,   287,   292,
     296,   302,   307,   312,   318,   323,   328,   333,   337,   342,
     346,   351,   355,   361,   366,   371,   376,   382,   387,   392,
     398,   403,   409,   414,   420,   425,   430,   434,   440,   445,
     451,   456,   461,   465,   471,   476,   482,   487,   492,   496,
     502,   507,   513,   518,   524,   529,   534,   538,   544,   549,
     554,   558,   564,   569,   574,   578,   583,   587,   593,   598,
     603,   607,   612,   616,   622,   627,   632,   636,   641,   645,
     651,   656,   661,   665,   670,   674,   680,   685,   690,   694,
     700,   705,   710,   714,   720,   725,   730,   734,   740,   745,
     750,   754,   760,   765,   769,   775,   780,   784,   790,   795,
     800,   804,   810,   815,   820,   824,   830,   835,   840,   844,
     850,   855,   860,   864,   869,   873,   878,   882,   887,   891,
     895,   900,   904,   908,   913,   917,   922,   926,   930,   934,
     939,   943,   948,   952,   956,   961,   965,   970,   974,   978,
     983,   987,   992,   996,  1000,  1004,  1007,  1010,  1014,  1018,
    1023,  1028,  1033,  1038,  1043,  1048,  1052,  1056,  1061,  1066,
    1070,  1075,  1080,  1085,  1090,  1095,  1099,  1103,  1107,  1111,
    1116,  1121,  1124,  1129,  1130,  1131,  1132,  1133,  1135,  1136,
    1137
  };

  // Print the state stack on the debug stream.
  void
  parser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
	 i != i_end; ++i)
      *yycdebug_ << ' ' << i->state;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  parser::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    /* Print the symbols being reduced, and their result.  */
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
	       << " (line " << yylno << "):" << std::endl;
    /* The symbols being reduced.  */
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  // Symbol number corresponding to token number t.
  parser::token_number_type
  parser::yytranslate_ (int t)
  {
    static
    const token_number_type
    translate_table[] =
    {
     0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104
    };
    const unsigned int user_token_number_max_ = 359;
    const token_number_type undef_token_ = 2;

    if (static_cast<int>(t) <= yyeof_)
      return yyeof_;
    else if (static_cast<unsigned int> (t) <= user_token_number_max_)
      return translate_table[t];
    else
      return undef_token_;
  }

/* Line 1064 of lalr1.cc  */
#line 1 "[Bison:b4_percent_define_default]"

} // yy
/* Line 1064 of lalr1.cc  */
#line 3532 "asm-parse.cc"
/* Line 1065 of lalr1.cc  */
#line 1139 "asm-parse.yy"

void
yy::parser::error(const location &l, const std::string &msg)
{
  std::cerr << l << ": " << msg << std::endl;
  exit_set (exit_parse);
}

